//+------------------------------------------------------------------+
//|                                   Detrended Price Oscillator.mq4 |
//|                                       Copyright  2008, Nievinny |
//|                                        http://www.viixtrader.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Nievinny"
#property link      "http://www.viixtrader.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 RoyalBlue
#property indicator_minimum 0
#property indicator_maximum 100
 
//---- input parameters
extern int RsiPeriod=14; //I add here
extern string    ____0____   = "Period of average";
extern int       DPOPeriod   = 14;
extern string    ____1____   = "Type of average: SMA - 0, EMA - 1, SMMA - 2, LWMA - 3";
extern int       MaType      = 0;
extern string    ____2____   = "Type of price: close - 0, open - 1, high - 2, low - 3";
extern int       PriceType   = 0;
extern string    ____3____   = "Moving Average Shift";
extern int       MaShift     = 0;

double RsiBuffer[];
double ExtMapBuffer1[];
int init()
{
   IndicatorBuffers(2);
      SetIndexBuffer(0,RsiBuffer);
      SetIndexBuffer(1,ExtMapBuffer1);
         IndicatorShortName("RSI of DPO("+DPOPeriod+", "+MaType+", "+PriceType+", "+MaShift+")");
   return(0);
}

int deinit() { return(0); }
int start()
{
   int i,counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--) ExtMapBuffer1[i] = iMA(NULL,0,1,0,MODE_SMA,PriceType,i) - iMA(NULL,0,DPOPeriod,MaShift,MaType,PriceType,i);
   for(i=limit; i>=0; i--) RsiBuffer[i] = iRSIOnArray(ExtMapBuffer1,0,RsiPeriod,i);
   return(0);
}